Imports System.Net
Imports System.Text

Public Class FDSTalk

#Region " FDSTalk.dll API Calls "
    Private Declare Sub Send_Message Lib "./FDSTalk.dll" (ByVal strMessage As String, ByVal IP As Integer, ByVal port As Integer)
    Private Declare Sub Service Lib "./FDSTalk.dll" ()
    Private Declare Sub Shutdown Lib "./FDSTalk.dll" ()
    Private Declare Sub Get_Response Lib "./FDSTalk.dll" (ByRef response As String)
    Private Declare Function Init Lib "./FDSTalk.dll" (ByVal port As Integer, ByVal password As String) As Boolean
#End Region

    Public Structure FDSConnection
        Dim strIP As String
        Dim strPass As String
        Dim intPort1 As Integer
        Dim intPort2 As Integer
    End Structure

    Private myFDS As FDSConnection
    Private longIP As Integer

    Public Function FDSSendMessage(ByVal msg As String) As Boolean
        msg = Mid(msg, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("msg " & msg, longIP, myFDS.intPort1)
        FDSSendMessage = True
    End Function
    Public Function FDSSendRaw(ByVal msg As String) As Boolean
        msg = Mid(msg, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message(msg, longIP, myFDS.intPort1)
        FDSSendRaw = True
    End Function
    Public Function FDSAdminMessage(ByVal msg As String) As Boolean
        msg = Mid(msg, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("amsg " & msg, longIP, myFDS.intPort1)
        FDSAdminMessage = True
    End Function
    Public Function FDSKickPlayer(ByVal pName As String) As Boolean
        pName = Mid(pName, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("kick " & pName, longIP, myFDS.intPort1)
        FDSKickPlayer = True
    End Function
    Public Function FDSBanPlayer(ByVal pName As String) As Boolean
        pName = Mid(pName, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("ban " & pName, longIP, myFDS.intPort1)
        FDSBanPlayer = True
    End Function
    Public Function FDSPagePlayer(ByVal pName As String, ByVal msg As String) As Boolean
        msg = Mid(msg, 1, 250)
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("page " & pName & " " & msg, longIP, myFDS.intPort1)
        FDSPagePlayer = True
    End Function
    Public Function FDSSendGameOver() As Boolean
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("gameover", longIP, myFDS.intPort1)
        FDSSendGameOver = True
    End Function
    Public Function FDSSendRestart() As Boolean
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("restart", longIP, myFDS.intPort1)
        FDSSendRestart = True
    End Function
    Public Function FDSSendServerQuit() As Boolean
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("quit", longIP, myFDS.intPort1)
        FDSSendServerQuit = True
    End Function
    Public Function FDSSendGameInfo() As Boolean
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("game_info", longIP, myFDS.intPort1)
        FDSSendGameInfo = True
    End Function
    Public Function FDSSendPlayerInfo() As Boolean
        Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Send_Message("player_info", longIP, myFDS.intPort1)
        FDSSendPlayerInfo = True
    End Function
    Public Function InitializeFDS(ByVal fds As FDSConnection) As Boolean
        myFDS = fds
        longIP = IPAddress.Parse(myFDS.strIP).Address
        If Init(fds.intPort2, fds.strPass) = True Then
            InitializeFDS = True
            Send_Message(myFDS.strPass, longIP, myFDS.intPort1)
        Else
            Return False
        End If
    End Function
    Public Function FDSService() As String
        Dim tmp As String = ""
        Service()
        Get_Response(tmp)
        If Len(tmp) <> 0 Then
            'return this properly for correct ingame processing at a later date
            FDSService = tmp
        End If
    End Function
    Public Sub FDSShutdown()
        Shutdown()
    End Sub
End Class
