Public Class PlayerInfo

#Region " Declares "

    Private sPlayerInfoString() As String
    Private bLoadingList As Boolean
    Private bNoPlayers As Boolean = True
    Private pPlayers() As PlayerInfo = Nothing

    Public Structure PlayerInfo
        Dim ID As String
        Dim Name As String
        Dim IPPort As String
        Dim CurScore As Long
        Dim CurTeam As String
        Dim ToS As String
        Dim Ping As String
        Dim KBits As String
        Dim Access As Integer
    End Structure

#End Region

#Region " Properties "

    Public ReadOnly Property GetLongPlayerInfo() As String()
        Get
            If Not sPlayerInfoString Is Nothing Then
                Return sPlayerInfoString
            Else
                Dim tmp() As String
                Return tmp
                bNoPlayers = True
            End If
        End Get
    End Property
    Public ReadOnly Property GetPlayer(ByVal id As Integer) As PlayerInfo
        Get
            If bNoPlayers = True Then
                Return Nothing
            Else
                Return iGetPlayer(id)
            End If
        End Get
    End Property

    Public ReadOnly Property PlayerCount() As Integer
        Get
            If sPlayerInfoString Is Nothing Then
                Return 0
            Else
                Return UBound(sPlayerInfoString)
            End If
        End Get
    End Property

    Public ReadOnly Property LoadingList() As Boolean
        Get
            Return bLoadingList
        End Get
    End Property

    Public Property NoPlayers() As Boolean
        Get
            Return bNoPlayers
        End Get
        Set(ByVal Value As Boolean)
            bNoPlayers = Value
        End Set
    End Property

#End Region

#Region " Methods "

    Public Function AddPlayer(ByVal FDSString As String) As Boolean
        If sPlayerInfoString Is Nothing Then
            ReDim sPlayerInfoString(0)
        Else
            ReDim Preserve sPlayerInfoString(UBound(sPlayerInfoString) + 1)
        End If
        sPlayerInfoString(UBound(sPlayerInfoString)) = FDSString
        bNoPlayers = False
    End Function

    Public Function StartList() As Boolean
        sPlayerInfoString = Nothing
        bLoadingList = True
    End Function

    Public Function EndList() As Boolean
        bLoadingList = False
    End Function

    Public Function GetPlayerID(ByVal player As String) As String
        Dim i As Integer
        If player <> "" Then
            For i = LBound(sPlayerInfoString) To UBound(sPlayerInfoString)
                If InStr(sPlayerInfoString(i), player) Then
                    Dim p As PlayerInfo
                    p = GetPlayer(i)
                    Return p.ID
                End If
            Next
        Else
            Return "0"
        End If
    End Function

    Public Function GetPlayerIp(ByVal player As String) As String
        Dim i As Integer
        If player.ToLower = "host" Then
            Return "127.0.0.1"
            Exit Function
        End If
        If player <> "" Then
            For i = LBound(sPlayerInfoString) To UBound(sPlayerInfoString)
                If InStr(sPlayerInfoString(i), player) Then
                    Dim p As PlayerInfo
                    p = GetPlayer(i)
                    Dim tmp() As String = Split(p.IPPort, ";")
                    Return tmp(0)
                    Exit Function
                End If
            Next
        End If
        Return ""
    End Function

    Public Function GetPlayerTeam(ByVal player As String) As String
        Dim i As Integer
        If Not player Is Nothing Then
            For i = 0 To UBound(sPlayerInfoString)
                If InStr(sPlayerInfoString(i).ToLower, player.ToLower) <> 0 Then
                    If InStr(sPlayerInfoString(i).ToLower, "gdi") Then
                        Return "GDI"
                        Exit Function
                    End If
                End If

                If InStr(sPlayerInfoString(i).ToLower, player.ToLower) <> 0 Then
                    If InStr(sPlayerInfoString(i).ToLower, "nod") Then
                        Return "NOD"
                        Exit Function
                    End If
                End If
            Next
        End If
    End Function

#End Region

#Region " Events "


#End Region

#Region " Internal "

    Private Function iGetPlayer(ByVal id As Integer) As PlayerInfo
        'normal nick
        '[22:29:34]   5 [DoA]Rohirrim6 754   NOD	224	213.66.118.241;19742  66      000.28.44
        'GS nick with spaces
        '[22:29:34]   6 That's right, ho                     224   NOD	179	24.116.73.1;1887      36      001.06.04
        Dim sn() As String, c As Integer, d As Integer, tmp As PlayerInfo, ii() As String
        d = 0
        ii = Split(Me.sPlayerInfoString(id), " ")
        For c = 0 To UBound(ii)
            If ii(c) <> "" Then
                ReDim Preserve sn(d)
                sn(d) = ii(c)
                d = d + 1
            End If
        Next
        'ok, we have a clean array of the values now...
        'break apart the tab group for team
        'return the playerinfo
        'ok, GS nicks can have more than 6 in the array, soo... to compensate for that, do a select here
        Select Case UBound(sn)
            Case 6
                Dim sl() As String
                sl = Split(sn(4), vbTab)
                tmp.ID = sn(1)
                tmp.Name = sn(2)
                tmp.CurScore = sn(3)
                tmp.CurTeam = sl(0)
                tmp.Ping = sl(1)
                tmp.IPPort = sl(2)
                tmp.KBits = sn(5)
                tmp.ToS = sn(6)
                tmp.Access = 5
                sl = Nothing
                Return tmp
            Case Else
                Dim sl() As String, modifier As Integer = (UBound(sn) - 6)
                sl = Split(sn(4 + modifier), vbTab)
                'build the name
                For c = 2 To (modifier + 2)
                    tmp.Name = tmp.Name & sn(c) & " "
                Next
                tmp.ID = sn(1)
                tmp.Name = tmp.Name.Trim
                tmp.CurScore = sn(3 + modifier)
                tmp.CurTeam = sl(0)
                tmp.Ping = sl(1)
                tmp.IPPort = sl(2)
                tmp.KBits = sn(5 + modifier)
                tmp.ToS = sn(6 + modifier)
                tmp.Access = 5
                sl = Nothing
                Return tmp
        End Select
    End Function
#End Region

End Class
