Public Class PlayerVoting

#Region " Constructor and Variables"

    Private Num_Yes_Votes As Integer
    Private Num_No_Votes As Integer
    Public Total_Votes As Integer
    Private frmStartup As frmStartup
    Private SuccessCommand As String
    Private FailureCommand As String
    Public VoteInProgress As Boolean = False
    Private m_Interval As Integer = 30000
    Private myTimer As Threading.Timer

    Public Sub New(ByVal success As String, ByVal failure As String, ByRef frm As frmStartup)
        'VoteInProgress = True
        SuccessCommand = success
        FailureCommand = failure
        frmStartup = frm
        Num_Yes_Votes = 0
        Num_No_Votes = 0
        Total_Votes = 0
        StartTimer(m_Interval)
    End Sub

#End Region

#Region " Garbage Collection "

    Private Disposed As Boolean
    Protected Overrides Sub Finalize()
        Dispose(False)
    End Sub

    Protected Overridable Overloads Sub Dispose(ByVal Disposing As Boolean)
        ' Check to see if Dispose has already been called.
        If Not (Me.Disposed) Then
            ' If disposing equals true, dispose all managed and
            ' unmanaged resources
            ' If it's false, dispose of only unmanaged resources

            If (Disposing) Then
                ' Dispose of managed resources.
                ' You can't refer to managed resources outside
                ' this if statement because the order in which objects 
                ' are finalized is not defined and you may end up 
                ' calling an object that has already been disposed of
            End If
        End If
        Me.Disposed = True
    End Sub

#End Region

    Private Sub OnTimer(ByVal State As Object)
        If VoteInProgress = True Then
            VoteInProgress = False
            StopTimer()
        Else
            VoteInProgress = True
        End If
    End Sub

    Private Sub StartTimer(ByVal period As Integer)
        ' Don't try to start a NULL timer.
        If IsNothing(myTimer) Then
            ' Create a callback to subroutine OnTimer
            Dim callback As New Threading.TimerCallback(AddressOf OnTimer)
            ' And start the timer, passing frequency specified in period.  Note: 
            ' Threading.Timer should not be confused with Timers.Timer.
            myTimer = New Threading.Timer(callback, Nothing, period, period)
            VoteInProgress = True
        End If
    End Sub

    Private Sub StopTimer()
        myTimer.Dispose()
        myTimer = Nothing
        If Num_Yes_Votes > Num_No_Votes Then
            If InStr(Me.SuccessCommand, " ") Then
                Dim tmp() As String
                tmp = Split(Me.SuccessCommand, " ")
                frmStartup.ProcessRemoteCommand(tmp(0), 0, tmp(1))
            Else
                frmStartup.ProcessRemoteCommand(Me.SuccessCommand, 0)
            End If
        Else
            frmStartup.ProcessRemoteCommand(Me.FailureCommand, 0)
        End If
        Me.Finalize()
    End Sub

    Public ReadOnly Property Enabled() As Boolean
        Get
            Enabled = VoteInProgress
        End Get
    End Property

    Public Sub CastVote(ByVal vote As Boolean, ByVal weight As Integer)
        If vote = True Then
            Num_Yes_Votes = Num_Yes_Votes + weight
        Else
            Num_No_Votes = Num_No_Votes + weight
        End If
        Total_Votes = Total_Votes + weight
    End Sub

End Class
