Public Class TempMods

#Region " Declrations "
    Dim ModTable As New Hashtable

    Enum Level As Integer
        FOUNDER = 0
        SOP = 1
        OP = 2
        HOP = 3
        TOP = 4
    End Enum
#End Region

#Region " Public Functions "
    Public Function AddTempMod(ByVal Nick As String, ByVal Access As Level) As String
        If ModTable.ContainsKey(Nick) Then
            If ModTable.Item(Nick) = Access Then
                Return Nick + " is already set as a " + GetAccessString(Access) + "."
            Else
                ModTable.Remove(Nick)
                ModTable.Add(Nick, Access)
                Return Nick + "'s access level changed to " + GetAccessString(Access) + "."
            End If
        End If
        ModTable.Add(Nick, Access)
        Return Nick + " has been set as a " + GetAccessString(Access) + "."
    End Function

    Public Function DelTempMod(ByVal Nick As String) As String
        Dim access As Level

        If ModTable.ContainsKey(Nick) Then
            access = ModTable.Item(Nick)
            ModTable.Remove(Nick)
            Return Nick + "'s " + Me.GetAccessString(access) + " privilages have been revoked."
        Else
            Return Nick + " is not currently set to have any access privilages."
        End If
    End Function

    Public Function GetModLevel(ByVal Nick As String) As Integer
        If ModTable.ContainsKey(Nick) Then
            Return ModTable.Item(Nick)
        End If

        Return -1 'Not found
    End Function

    Public Sub ClearAllMods()
        ModTable.Clear()
    End Sub

    Public Function ShowTempMods(ByVal Access As Level) As String
        Dim nicks As String = ""
        Dim rs As IDictionaryEnumerator

        If ModTable.Count = 0 Then
            Return "No temporary moderators with any access privilages present."
        End If

        rs = ModTable.GetEnumerator()

        rs.Reset()
        While rs.MoveNext
            If rs.Value = Access Then nicks = nicks + rs.Key + ", "
        End While

        If nicks.Length = 0 Then
            Return "No temporary moderators with " + GetAccessString(Access) + " access present."
        Else
            nicks = nicks.Substring(0, nicks.Length - 2)
            Return "Current temporary moderators with " + GetAccessString(Access) + " access are: " + nicks
        End If
    End Function

#End Region

#Region " Internal Functions "
    Private Function GetAccessString(ByVal Access As Level)
        Select Case Access
            Case Level.FOUNDER
                Return "founder"
            Case Level.SOP
                Return "head mod"
            Case Level.OP
                Return "mod"
            Case Level.HOP
                Return "half mod"
            Case Level.TOP
                Return "temp mod"
        End Select
    End Function
#End Region

End Class